~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/scripts/faddr2line

Version: ~ [ linux-6.12-rc7 ] ~ [ linux-6.11.7 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.60 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.116 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.171 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.229 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.285 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.323 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.12 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

Diff markup

Differences between /scripts/faddr2line (Version linux-6.12-rc7) and /scripts/faddr2line (Version linux-6.9.12)


  1 #!/bin/bash                                         1 #!/bin/bash
  2 # SPDX-License-Identifier: GPL-2.0                  2 # SPDX-License-Identifier: GPL-2.0
  3 #                                                   3 #
  4 # Translate stack dump function offsets.            4 # Translate stack dump function offsets.
  5 #                                                   5 #
  6 # addr2line doesn't work with KASLR addresses.      6 # addr2line doesn't work with KASLR addresses.  This works similarly to
  7 # addr2line, but instead takes the 'func+0x123      7 # addr2line, but instead takes the 'func+0x123' format as input:
  8 #                                                   8 #
  9 #   $ ./scripts/faddr2line ~/k/vmlinux meminfo      9 #   $ ./scripts/faddr2line ~/k/vmlinux meminfo_proc_show+0x5/0x568
 10 #   meminfo_proc_show+0x5/0x568:                   10 #   meminfo_proc_show+0x5/0x568:
 11 #   meminfo_proc_show at fs/proc/meminfo.c:27      11 #   meminfo_proc_show at fs/proc/meminfo.c:27
 12 #                                                  12 #
 13 # If the address is part of an inlined functio     13 # If the address is part of an inlined function, the full inline call chain is
 14 # printed:                                         14 # printed:
 15 #                                                  15 #
 16 #   $ ./scripts/faddr2line ~/k/vmlinux native_     16 #   $ ./scripts/faddr2line ~/k/vmlinux native_write_msr+0x6/0x27
 17 #   native_write_msr+0x6/0x27:                     17 #   native_write_msr+0x6/0x27:
 18 #   arch_static_branch at arch/x86/include/asm     18 #   arch_static_branch at arch/x86/include/asm/msr.h:121
 19 #    (inlined by) static_key_false at include/     19 #    (inlined by) static_key_false at include/linux/jump_label.h:125
 20 #    (inlined by) native_write_msr at arch/x86     20 #    (inlined by) native_write_msr at arch/x86/include/asm/msr.h:125
 21 #                                                  21 #
 22 # The function size after the '/' in the input     22 # The function size after the '/' in the input is optional, but recommended.
 23 # It's used to help disambiguate any duplicate     23 # It's used to help disambiguate any duplicate symbol names, which can occur
 24 # rarely.  If the size is omitted for a duplic     24 # rarely.  If the size is omitted for a duplicate symbol then it's possible for
 25 # multiple code sites to be printed:               25 # multiple code sites to be printed:
 26 #                                                  26 #
 27 #   $ ./scripts/faddr2line ~/k/vmlinux raw_ioc     27 #   $ ./scripts/faddr2line ~/k/vmlinux raw_ioctl+0x5
 28 #   raw_ioctl+0x5/0x20:                            28 #   raw_ioctl+0x5/0x20:
 29 #   raw_ioctl at drivers/char/raw.c:122            29 #   raw_ioctl at drivers/char/raw.c:122
 30 #                                                  30 #
 31 #   raw_ioctl+0x5/0xb1:                            31 #   raw_ioctl+0x5/0xb1:
 32 #   raw_ioctl at net/ipv4/raw.c:876                32 #   raw_ioctl at net/ipv4/raw.c:876
 33 #                                                  33 #
 34 # Multiple addresses can be specified on a sin     34 # Multiple addresses can be specified on a single command line:
 35 #                                                  35 #
 36 #   $ ./scripts/faddr2line ~/k/vmlinux type_sh     36 #   $ ./scripts/faddr2line ~/k/vmlinux type_show+0x10/45 free_reserved_area+0x90
 37 #   type_show+0x10/0x2d:                           37 #   type_show+0x10/0x2d:
 38 #   type_show at drivers/video/backlight/backl     38 #   type_show at drivers/video/backlight/backlight.c:213
 39 #                                                  39 #
 40 #   free_reserved_area+0x90/0x123:                 40 #   free_reserved_area+0x90/0x123:
 41 #   free_reserved_area at mm/page_alloc.c:6429     41 #   free_reserved_area at mm/page_alloc.c:6429 (discriminator 2)
 42                                                    42 
 43                                                    43 
 44 set -o errexit                                     44 set -o errexit
 45 set -o nounset                                     45 set -o nounset
 46                                                    46 
 47 usage() {                                          47 usage() {
 48         echo "usage: faddr2line [--list] <obje     48         echo "usage: faddr2line [--list] <object file> <func+offset> <func+offset>..." >&2
 49         exit 1                                     49         exit 1
 50 }                                                  50 }
 51                                                    51 
 52 warn() {                                           52 warn() {
 53         echo "$1" >&2                              53         echo "$1" >&2
 54 }                                                  54 }
 55                                                    55 
 56 die() {                                            56 die() {
 57         echo "ERROR: $1" >&2                       57         echo "ERROR: $1" >&2
 58         exit 1                                     58         exit 1
 59 }                                                  59 }
 60                                                    60 
 61 UTIL_SUFFIX=""                                     61 UTIL_SUFFIX=""
 62 if [[ "${LLVM:-}" == "" ]]; then                   62 if [[ "${LLVM:-}" == "" ]]; then
 63         UTIL_PREFIX=${CROSS_COMPILE:-}             63         UTIL_PREFIX=${CROSS_COMPILE:-}
 64 else                                               64 else
 65         UTIL_PREFIX=llvm-                          65         UTIL_PREFIX=llvm-
 66                                                    66 
 67         if [[ "${LLVM}" == *"/" ]]; then           67         if [[ "${LLVM}" == *"/" ]]; then
 68                 UTIL_PREFIX=${LLVM}${UTIL_PREF     68                 UTIL_PREFIX=${LLVM}${UTIL_PREFIX}
 69         elif [[ "${LLVM}" == "-"* ]]; then         69         elif [[ "${LLVM}" == "-"* ]]; then
 70                 UTIL_SUFFIX=${LLVM}                70                 UTIL_SUFFIX=${LLVM}
 71         fi                                         71         fi
 72 fi                                                 72 fi
 73                                                    73 
 74 READELF="${UTIL_PREFIX}readelf${UTIL_SUFFIX}"      74 READELF="${UTIL_PREFIX}readelf${UTIL_SUFFIX}"
 75 ADDR2LINE="${UTIL_PREFIX}addr2line${UTIL_SUFFI     75 ADDR2LINE="${UTIL_PREFIX}addr2line${UTIL_SUFFIX}"
 76 AWK="awk"                                          76 AWK="awk"
 77 GREP="grep"                                        77 GREP="grep"
 78                                                    78 
 79 command -v ${AWK} >/dev/null 2>&1 || die "${AW     79 command -v ${AWK} >/dev/null 2>&1 || die "${AWK} isn't installed"
 80 command -v ${READELF} >/dev/null 2>&1 || die "     80 command -v ${READELF} >/dev/null 2>&1 || die "${READELF} isn't installed"
 81 command -v ${ADDR2LINE} >/dev/null 2>&1 || die     81 command -v ${ADDR2LINE} >/dev/null 2>&1 || die "${ADDR2LINE} isn't installed"
 82                                                    82 
 83 # Try to figure out the source directory prefi     83 # Try to figure out the source directory prefix so we can remove it from the
 84 # addr2line output.  HACK ALERT: This assumes      84 # addr2line output.  HACK ALERT: This assumes that start_kernel() is in
 85 # init/main.c!  This only works for vmlinux.       85 # init/main.c!  This only works for vmlinux.  Otherwise it falls back to
 86 # printing the absolute path.                      86 # printing the absolute path.
 87 find_dir_prefix() {                                87 find_dir_prefix() {
 88         local start_kernel_addr=$(echo "${ELF_ !!  88         local objfile=$1
                                                   >>  89 
                                                   >>  90         local start_kernel_addr=$(${READELF} --symbols --wide $objfile | sed 's/\[.*\]//' |
 89                 ${AWK} '$8 == "start_kernel" {     91                 ${AWK} '$8 == "start_kernel" {printf "0x%s", $2}')
 90         [[ -z $start_kernel_addr ]] && return      92         [[ -z $start_kernel_addr ]] && return
 91                                                    93 
 92         run_addr2line ${start_kernel_addr} ""  !!  94         local file_line=$(${ADDR2LINE} -e $objfile $start_kernel_addr)
 93         [[ -z $ADDR2LINE_OUT ]] && return      !!  95         [[ -z $file_line ]] && return
 94                                                    96 
 95         local file_line=${ADDR2LINE_OUT#* at } << 
 96         if [[ -z $file_line ]] || [[ $file_lin << 
 97                 return                         << 
 98         fi                                     << 
 99         local prefix=${file_line%init/main.c:*     97         local prefix=${file_line%init/main.c:*}
100         if [[ -z $prefix ]] || [[ $prefix = $f     98         if [[ -z $prefix ]] || [[ $prefix = $file_line ]]; then
101                 return                             99                 return
102         fi                                        100         fi
103                                                   101 
104         DIR_PREFIX=$prefix                        102         DIR_PREFIX=$prefix
105         return 0                                  103         return 0
106 }                                                 104 }
107                                                   105 
108 run_readelf() {                                << 
109         local objfile=$1                       << 
110         local out=$(${READELF} --file-header - << 
111                                                << 
112         # This assumes that readelf first prin << 
113         # Note: It seems that GNU readelf does << 
114         # line when multiple options are given << 
115         ELF_FILEHEADER=$(echo "${out}" | sed - << 
116         ELF_SECHEADERS=$(echo "${out}" | sed - << 
117         ELF_SYMS=$(echo "${out}" | sed -n '/Sy << 
118 }                                              << 
119                                                << 
120 check_vmlinux() {                              << 
121         # vmlinux uses absolute addresses in t << 
122         # section offsets.                     << 
123         IS_VMLINUX=0                           << 
124         local file_type=$(echo "${ELF_FILEHEAD << 
125                 ${AWK} '$1 == "Type:" { print  << 
126         if [[ $file_type = "EXEC" ]] || [[ $fi << 
127                 IS_VMLINUX=1                   << 
128         fi                                     << 
129 }                                              << 
130                                                << 
131 init_addr2line() {                             << 
132         local objfile=$1                       << 
133                                                << 
134         check_vmlinux                          << 
135                                                << 
136         ADDR2LINE_ARGS="--functions --pretty-p << 
137         if [[ $IS_VMLINUX = 1 ]]; then         << 
138                 # If the executable file is vm << 
139                 # addr2line, so we can launch  << 
140                 coproc ADDR2LINE_PROC (${ADDR2 << 
141         fi                                     << 
142 }                                              << 
143                                                << 
144 run_addr2line() {                              << 
145         local addr=$1                          << 
146         local sec_name=$2                      << 
147                                                << 
148         if [[ $IS_VMLINUX = 1 ]]; then         << 
149                 # We send to the addr2line pro << 
150                 # value, i.e., something that  << 
151                 # (i.e., ","). This causes add << 
152                 # our address, then (2) either << 
153                 # using binutils' addr2line),  << 
154                 echo ${addr} >& "${ADDR2LINE_P << 
155                 echo "," >& "${ADDR2LINE_PROC[ << 
156                 local first_line               << 
157                 read -r first_line <& "${ADDR2 << 
158                 ADDR2LINE_OUT=$(echo "${first_ << 
159                 while read -r line <& "${ADDR2 << 
160                         if [[ "$line" == "?? ? << 
161                                 break          << 
162                         fi                     << 
163                         ADDR2LINE_OUT+=$'\n'$( << 
164                 done                           << 
165         else                                   << 
166                 # Run addr2line as a single in << 
167                 local sec_arg                  << 
168                 [[ -z $sec_name ]] && sec_arg= << 
169                 ADDR2LINE_OUT=$(${ADDR2LINE} $ << 
170         fi                                     << 
171 }                                              << 
172                                                << 
173 __faddr2line() {                                  106 __faddr2line() {
174         local objfile=$1                          107         local objfile=$1
175         local func_addr=$2                        108         local func_addr=$2
176         local dir_prefix=$3                       109         local dir_prefix=$3
177         local print_warnings=$4                   110         local print_warnings=$4
178                                                   111 
179         local sym_name=${func_addr%+*}            112         local sym_name=${func_addr%+*}
180         local func_offset=${func_addr#*+}         113         local func_offset=${func_addr#*+}
181         func_offset=${func_offset%/*}             114         func_offset=${func_offset%/*}
182         local user_size=                          115         local user_size=
                                                   >> 116         local file_type
                                                   >> 117         local is_vmlinux=0
183         [[ $func_addr =~ "/" ]] && user_size=$    118         [[ $func_addr =~ "/" ]] && user_size=${func_addr#*/}
184                                                   119 
185         if [[ -z $sym_name ]] || [[ -z $func_o    120         if [[ -z $sym_name ]] || [[ -z $func_offset ]] || [[ $sym_name = $func_addr ]]; then
186                 warn "bad func+offset $func_ad    121                 warn "bad func+offset $func_addr"
187                 DONE=1                            122                 DONE=1
188                 return                            123                 return
189         fi                                        124         fi
190                                                   125 
                                                   >> 126         # vmlinux uses absolute addresses in the section table rather than
                                                   >> 127         # section offsets.
                                                   >> 128         local file_type=$(${READELF} --file-header $objfile |
                                                   >> 129                 ${AWK} '$1 == "Type:" { print $2; exit }')
                                                   >> 130         if [[ $file_type = "EXEC" ]] || [[ $file_type == "DYN" ]]; then
                                                   >> 131                 is_vmlinux=1
                                                   >> 132         fi
                                                   >> 133 
191         # Go through each of the object's symb    134         # Go through each of the object's symbols which match the func name.
192         # In rare cases there might be duplica    135         # In rare cases there might be duplicates, in which case we print all
193         # matches.                                136         # matches.
194         while read line; do                       137         while read line; do
195                 local fields=($line)              138                 local fields=($line)
196                 local sym_addr=0x${fields[1]}     139                 local sym_addr=0x${fields[1]}
197                 local sym_elf_size=${fields[2]    140                 local sym_elf_size=${fields[2]}
198                 local sym_sec=${fields[6]}        141                 local sym_sec=${fields[6]}
199                 local sec_size                    142                 local sec_size
200                 local sec_name                    143                 local sec_name
201                                                   144 
202                 # Get the section size:           145                 # Get the section size:
203                 sec_size=$(echo "${ELF_SECHEAD !! 146                 sec_size=$(${READELF} --section-headers --wide $objfile |
                                                   >> 147                         sed 's/\[ /\[/' |
204                         ${AWK} -v sec=$sym_sec    148                         ${AWK} -v sec=$sym_sec '$1 == "[" sec "]" { print "0x" $6; exit }')
205                                                   149 
206                 if [[ -z $sec_size ]]; then       150                 if [[ -z $sec_size ]]; then
207                         warn "bad section size    151                         warn "bad section size: section: $sym_sec"
208                         DONE=1                    152                         DONE=1
209                         return                    153                         return
210                 fi                                154                 fi
211                                                   155 
212                 # Get the section name:           156                 # Get the section name:
213                 sec_name=$(echo "${ELF_SECHEAD !! 157                 sec_name=$(${READELF} --section-headers --wide $objfile |
                                                   >> 158                         sed 's/\[ /\[/' |
214                         ${AWK} -v sec=$sym_sec    159                         ${AWK} -v sec=$sym_sec '$1 == "[" sec "]" { print $2; exit }')
215                                                   160 
216                 if [[ -z $sec_name ]]; then       161                 if [[ -z $sec_name ]]; then
217                         warn "bad section name    162                         warn "bad section name: section: $sym_sec"
218                         DONE=1                    163                         DONE=1
219                         return                    164                         return
220                 fi                                165                 fi
221                                                   166 
222                 # Calculate the symbol size.      167                 # Calculate the symbol size.
223                 #                                 168                 #
224                 # Unfortunately we can't use t    169                 # Unfortunately we can't use the ELF size, because kallsyms
225                 # also includes the padding by    170                 # also includes the padding bytes in its size calculation.  For
226                 # kallsyms, the size calculati    171                 # kallsyms, the size calculation is the distance between the
227                 # symbol and the next symbol i    172                 # symbol and the next symbol in a sorted list.
228                 local sym_size                    173                 local sym_size
229                 local cur_sym_addr                174                 local cur_sym_addr
230                 local found=0                     175                 local found=0
231                 while read line; do               176                 while read line; do
232                         local fields=($line)      177                         local fields=($line)
233                         cur_sym_addr=0x${field    178                         cur_sym_addr=0x${fields[1]}
234                         local cur_sym_elf_size    179                         local cur_sym_elf_size=${fields[2]}
235                         local cur_sym_name=${f    180                         local cur_sym_name=${fields[7]:-}
236                                                   181 
237                         # is_mapping_symbol(cu    182                         # is_mapping_symbol(cur_sym_name)
238                         if [[ ${cur_sym_name}     183                         if [[ ${cur_sym_name} =~ ^(\.L|L0|\$) ]]; then
239                                 continue          184                                 continue
240                         fi                        185                         fi
241                                                   186 
242                         if [[ $cur_sym_addr =     187                         if [[ $cur_sym_addr = $sym_addr ]] &&
243                            [[ $cur_sym_elf_siz    188                            [[ $cur_sym_elf_size = $sym_elf_size ]] &&
244                            [[ $cur_sym_name =     189                            [[ $cur_sym_name = $sym_name ]]; then
245                                 found=1           190                                 found=1
246                                 continue          191                                 continue
247                         fi                        192                         fi
248                                                   193 
249                         if [[ $found = 1 ]]; t    194                         if [[ $found = 1 ]]; then
250                                 sym_size=$(($c    195                                 sym_size=$(($cur_sym_addr - $sym_addr))
251                                 [[ $sym_size -    196                                 [[ $sym_size -lt $sym_elf_size ]] && continue;
252                                 found=2           197                                 found=2
253                                 break             198                                 break
254                         fi                        199                         fi
255                 done < <(echo "${ELF_SYMS}" |  !! 200                 done < <(${READELF} --symbols --wide $objfile | sed 's/\[.*\]//' | ${AWK} -v sec=$sym_sec '$7 == sec' | sort --key=2)
256                                                   201 
257                 if [[ $found = 0 ]]; then         202                 if [[ $found = 0 ]]; then
258                         warn "can't find symbo    203                         warn "can't find symbol: sym_name: $sym_name sym_sec: $sym_sec sym_addr: $sym_addr sym_elf_size: $sym_elf_size"
259                         DONE=1                    204                         DONE=1
260                         return                    205                         return
261                 fi                                206                 fi
262                                                   207 
263                 # If nothing was found after t    208                 # If nothing was found after the symbol, assume it's the last
264                 # symbol in the section.          209                 # symbol in the section.
265                 [[ $found = 1 ]] && sym_size=$    210                 [[ $found = 1 ]] && sym_size=$(($sec_size - $sym_addr))
266                                                   211 
267                 if [[ -z $sym_size ]] || [[ $s    212                 if [[ -z $sym_size ]] || [[ $sym_size -le 0 ]]; then
268                         warn "bad symbol size:    213                         warn "bad symbol size: sym_addr: $sym_addr cur_sym_addr: $cur_sym_addr"
269                         DONE=1                    214                         DONE=1
270                         return                    215                         return
271                 fi                                216                 fi
272                                                   217 
273                 sym_size=0x$(printf %x $sym_si    218                 sym_size=0x$(printf %x $sym_size)
274                                                   219 
275                 # Calculate the address from u    220                 # Calculate the address from user-supplied offset:
276                 local addr=$(($sym_addr + $fun    221                 local addr=$(($sym_addr + $func_offset))
277                 if [[ -z $addr ]] || [[ $addr     222                 if [[ -z $addr ]] || [[ $addr = 0 ]]; then
278                         warn "bad address: $sy    223                         warn "bad address: $sym_addr + $func_offset"
279                         DONE=1                    224                         DONE=1
280                         return                    225                         return
281                 fi                                226                 fi
282                 addr=0x$(printf %x $addr)         227                 addr=0x$(printf %x $addr)
283                                                   228 
284                 # If the user provided a size,    229                 # If the user provided a size, make sure it matches the symbol's size:
285                 if [[ -n $user_size ]] && [[ $    230                 if [[ -n $user_size ]] && [[ $user_size -ne $sym_size ]]; then
286                         [[ $print_warnings = 1    231                         [[ $print_warnings = 1 ]] &&
287                                 echo "skipping    232                                 echo "skipping $sym_name address at $addr due to size mismatch ($user_size != $sym_size)"
288                         continue;                 233                         continue;
289                 fi                                234                 fi
290                                                   235 
291                 # Make sure the provided offse    236                 # Make sure the provided offset is within the symbol's range:
292                 if [[ $func_offset -gt $sym_si    237                 if [[ $func_offset -gt $sym_size ]]; then
293                         [[ $print_warnings = 1    238                         [[ $print_warnings = 1 ]] &&
294                                 echo "skipping    239                                 echo "skipping $sym_name address at $addr due to size mismatch ($func_offset > $sym_size)"
295                         continue                  240                         continue
296                 fi                                241                 fi
297                                                   242 
298                 # In case of duplicates or mul    243                 # In case of duplicates or multiple addresses specified on the
299                 # cmdline, separate multiple e    244                 # cmdline, separate multiple entries with a blank line:
300                 [[ $FIRST = 0 ]] && echo          245                 [[ $FIRST = 0 ]] && echo
301                 FIRST=0                           246                 FIRST=0
302                                                   247 
303                 echo "$sym_name+$func_offset/$    248                 echo "$sym_name+$func_offset/$sym_size:"
304                                                   249 
305                 # Pass section address to addr    250                 # Pass section address to addr2line and strip absolute paths
306                 # from the output:                251                 # from the output:
307                 run_addr2line $addr $sec_name  !! 252                 local args="--functions --pretty-print --inlines --exe=$objfile"
308                 local output=$(echo "${ADDR2LI !! 253                 [[ $is_vmlinux = 0 ]] && args="$args --section=$sec_name"
                                                   >> 254                 local output=$(${ADDR2LINE} $args $addr | sed "s; $dir_prefix\(\./\)*; ;")
309                 [[ -z $output ]] && continue      255                 [[ -z $output ]] && continue
310                                                   256 
311                 # Default output (non --list):    257                 # Default output (non --list):
312                 if [[ $LIST = 0 ]]; then          258                 if [[ $LIST = 0 ]]; then
313                         echo "$output" | while    259                         echo "$output" | while read -r line
314                         do                        260                         do
315                                 echo $line        261                                 echo $line
316                         done                      262                         done
317                         DONE=1;                   263                         DONE=1;
318                         continue                  264                         continue
319                 fi                                265                 fi
320                                                   266 
321                 # For --list, show each line w    267                 # For --list, show each line with its corresponding source code:
322                 echo "$output" | while read -r    268                 echo "$output" | while read -r line
323                 do                                269                 do
324                         echo                      270                         echo
325                         echo $line                271                         echo $line
326                         n=$(echo $line | sed '    272                         n=$(echo $line | sed 's/.*:\([0-9]\+\).*/\1/g')
327                         n1=$[$n-5]                273                         n1=$[$n-5]
328                         n2=$[$n+5]                274                         n2=$[$n+5]
329                         f=$(echo $line | sed '    275                         f=$(echo $line | sed 's/.*at \(.\+\):.*/\1/g')
330                         ${AWK} 'NR>=strtonum("    276                         ${AWK} 'NR>=strtonum("'$n1'") && NR<=strtonum("'$n2'") { if (NR=='$n') printf(">%d<", NR); else printf(" %d ", NR); printf("\t%s\n", $0)}' $f
331                 done                              277                 done
332                                                   278 
333                 DONE=1                            279                 DONE=1
334                                                   280 
335         done < <(echo "${ELF_SYMS}" | sed 's/\ !! 281         done < <(${READELF} --symbols --wide $objfile | sed 's/\[.*\]//' | ${AWK} -v fn=$sym_name '$8 == fn')
336 }                                                 282 }
337                                                   283 
338 [[ $# -lt 2 ]] && usage                           284 [[ $# -lt 2 ]] && usage
339                                                   285 
340 objfile=$1                                        286 objfile=$1
341                                                   287 
342 LIST=0                                            288 LIST=0
343 [[ "$objfile" == "--list" ]] && LIST=1 && shif    289 [[ "$objfile" == "--list" ]] && LIST=1 && shift && objfile=$1
344                                                   290 
345 [[ ! -f $objfile ]] && die "can't find objfile    291 [[ ! -f $objfile ]] && die "can't find objfile $objfile"
346 shift                                             292 shift
347                                                   293 
348 run_readelf $objfile                           !! 294 ${READELF} --section-headers --wide $objfile | ${GREP} -q '\.debug_info' || die "CONFIG_DEBUG_INFO not enabled"
349                                                << 
350 echo "${ELF_SECHEADERS}" | ${GREP} -q '\.debug << 
351                                                << 
352 init_addr2line $objfile                        << 
353                                                   295 
354 DIR_PREFIX=supercalifragilisticexpialidocious     296 DIR_PREFIX=supercalifragilisticexpialidocious
355 find_dir_prefix                                !! 297 find_dir_prefix $objfile
356                                                   298 
357 FIRST=1                                           299 FIRST=1
358 while [[ $# -gt 0 ]]; do                          300 while [[ $# -gt 0 ]]; do
359         func_addr=$1                              301         func_addr=$1
360         shift                                     302         shift
361                                                   303 
362         # print any matches found                 304         # print any matches found
363         DONE=0                                    305         DONE=0
364         __faddr2line $objfile $func_addr $DIR_    306         __faddr2line $objfile $func_addr $DIR_PREFIX 0
365                                                   307 
366         # if no match was found, print warning    308         # if no match was found, print warnings
367         if [[ $DONE = 0 ]]; then                  309         if [[ $DONE = 0 ]]; then
368                 __faddr2line $objfile $func_ad    310                 __faddr2line $objfile $func_addr $DIR_PREFIX 1
369                 warn "no match for $func_addr"    311                 warn "no match for $func_addr"
370         fi                                        312         fi
371 done                                              313 done
                                                      

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php